﻿import flash.geom.Rectangle;
import flash.display.BitmapData;

//constants
var DIM_VALUE = 50;
var BRIGHT_VALUE = 100;
var SPACE:Number = 5;//between each thumbnail

//reference back to controller
var controller:PhotoController;

//so controller can resize me:
var myWidth:Number;
var myHeight:Number;

//to manage height (only for vertical)
var topEdge:Number;

//to manage width (only for horiztontal)
var leftEdge:Number;
//for rollover (only used in horizontal)
rollover_txt.text = "";

//for scrubber/arrows
var scrollPosition:Number;
var maskRect:Rectangle; 
var maxScroll:Number;
var pressing = undefined;
var keepPressingInterval = undefined;
var keepScrollingTimeout = undefined;

//only used by horizontal:
left_btn.onPress = function(){
	nudgeThumbs(-1);
	pressing = -1;
}
right_btn.onPress = function(){
	nudgeThumbs(1);
	pressing = 1;
}

//only used by vertical:
up_btn.onPress = function(){
	nudgeThumbs(-1);
	pressing = -1;
}
down_btn.onPress = function(){
	nudgeThumbs(1);
	pressing = 1;
}

//required:
function setController(p_controller:PhotoController){
	controller = p_controller;
	displayThumbs();
}

function clickThumb(){
	controller.clickThumb(this.imageInfo);
	highlightOnly(this);
}

function rollThumb(){
	rollover_txt.text = this.imageInfo.name;
	this._alpha = BRIGHT_VALUE;
}

function rollOffThumb(){
	rollover_txt.text = "";
	this._alpha = this.selected ? BRIGHT_VALUE : DIM_VALUE;
}

function highlightOnly(clip:MovieClip){
	//dim everything:
	for (var i in thumbHolder){
		if( thumbHolder[i] instanceof MovieClip){
			thumbHolder[i].selected = false;
			thumbHolder[i]._alpha = DIM_VALUE;
		}
	}
	//set selected and highlight this one:
	clip.selected = true;
	clip._alpha = BRIGHT_VALUE;
}

//catchall for any mouse up
onMouseUp = function (){
	delete onMouseMove;
	pressing = undefined;
	if( keepPressingInterval != undefined ){
		clearInterval(keepPressingInterval);
	}
	if( keepScrollingTimeout != undefined ){
		clearTimeout(keepScrollingTimeout);
	}
}

function nudgeThumbs(direction:Number){
	var jumpDistance = 100;
	var destination = scrollPosition + jumpDistance * direction;
	var totalSteps = 10;
	var step = (destination - scrollPosition) / totalSteps;

	var nudgeInterval = setInterval(function(){
				scrollPosition += step;
				totalSteps--;
				updateScrollPosition();
				updateScrubberPosition();//only for horizontal
				if (totalSteps == 0){
					//clear this interval
					clearInterval(nudgeInterval);
					//set up timeout
					if( keepScrollingTimeout != undefined ){
						clearTimeout(keepScrollingTimeout);
					}
					//clearTimeout(keepScrollingTimeout);
					keepScrollingTimeout = setTimeout(checkKeepScrolling, 700, step);
				}
				updateAfterEvent();
			},10,this);
	
}

function checkKeepScrolling(step){
	if (pressing == undefined) return;
	keepPressingInterval = setInterval(function(){
							scrollPosition += step/1.5;
							updateScrollPosition();
							updateScrubberPosition();//only for horizontal
							updateAfterEvent();
							}, 10, this);
	
}

//===========
//supports showImage, when someone else (other than thumbnails) picks an image
//===========
function showImage(imageInfo:ImageInfo){
	//find a matching thumbnail
	for (var i in thumbHolder){
		if( thumbHolder[i] instanceof MovieClip){
			if( thumbHolder[i].imageInfo.ID == imageInfo.ID ){
				highlightOnly(thumbHolder[i]);
				return;
			}
		}
	}
}