﻿import flash.geom.Rectangle;
import flash.geom.Point;
import flash.geom.Matrix;
class ProgressBar extends MovieClip{
	private var rect:Rectangle;
	private var target:MovieClip;
	
	//created here
	private var bar:MovieClip;
	private var backdrop:MovieClip;
	
	//CONSTANTS
	//alpha percentage jumps when fading up:
	private var STEP:Number = 2;
	
	//fade up interval frequency (in milliseconds):
	private var FREQUENCY:Number = 10;
	
	//color of cover
	private var BACKDROP_COLOR:Number = 0x000000;
	
	//color of progress bar
	private var BAR_COLOR:Number = 0xFF0000;
	
	//height of progress bar
	private var BAR_HEIGHT:Number = 20;// undefined;//leave undefined for full height
	
	function ProgressBar(){
		this._x = rect.left;
		this._y = rect.top;
		
		backdrop = this.createEmptyMovieClip("backdrop",0);
		bar = this.createEmptyMovieClip("bar",1);
		
		rect.offsetPoint(new Point(this._x*-1, this._y*-1));
		
		fillClipWithRect(backdrop, rect, BACKDROP_COLOR);
		
		if (BAR_HEIGHT == undefined){
			fillClipWithRect(bar, rect, BAR_COLOR);
		}else{
			//make thin rect and center it vertically
			var y = (rect.height - BAR_HEIGHT)/2 - BAR_HEIGHT;
			var thinRect:Rectangle = new Rectangle(rect.x, y, rect.width, BAR_HEIGHT)
			fillClipWithRect(bar, thinRect, BAR_COLOR);
		}

		
		bar._visible = false;
		bar.transform.matrix = new Matrix(0,0,0,1,0,0);

	}
	function onLoadComplete (p_target){
		var SPEED = 2;
		
		if(p_target == target){
			var interval = setInterval(function(ref){
								ref.bar._alpha -= ref.STEP;
								ref.backdrop._alpha -= ref.STEP;
								if(ref.bar._alpha < 0 ){
									//they'll get disposed when the "bars" holder is
									clearInterval(interval);
								}
									}, FREQUENCY, this);
		}
	}
	//util
	private function fillClipWithRect(clip, rect, color){
		clip.beginFill(color);
		clip.lineTo(rect.left, rect.top);
		clip.lineTo(rect.left, rect.bottom);
		clip.lineTo(rect.right, rect.bottom);
		clip.lineTo(rect.right, rect.top);
		clip.lineTo(rect.left, rect.top);
		clip.endFill();
	}
	function onLoadStart (p_target){
		if(p_target == target){
			bar._visible = true;
		}
	}
	function onLoadProgress (p_target, bytesLoaded, bytesTotal){
		if(p_target == target){
			var p = (bytesLoaded/bytesTotal);
			var scaled = new Matrix(p,0,0,1,0,0);
			bar.transform.matrix = scaled;
		}
	}
	
	
}